Index: /branches/0.4/web/addons/job_monarch/graph.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/graph.php	(revision 707)
+++ /branches/0.4/web/addons/job_monarch/graph.php	(revision 708)
@@ -23,5 +23,5 @@
  */
 
-global $metrics, $rrds, $range, $start, $r;
+global $metrics, $rrds, $range, $start, $r, $conf;
 $range = $r;
 
@@ -506,5 +506,5 @@
 		$end = floor($end / 672) * 672;
 
-	$command = RRDTOOL . " graph - --start $start --end $end ".
+	$command = $conf['rrdtool']. " graph - --start $start --end $end ".
 		"--width $width --height $height $lower_limit ".
 		"--title '$title' $extras $background ".
@@ -521,5 +521,5 @@
 
 else {
-	$command = RRDTOOL . " graph - --start $period_start --end $period_stop ".
+	$command = $conf['rrdtool'] . " graph - --start $period_start --end $period_stop ".
 		"--width $width --height $height $lower_limit ".
 		"--title '$title' $extras $background ".
Index: /branches/0.4/web/addons/job_monarch/image.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/image.php	(revision 707)
+++ /branches/0.4/web/addons/job_monarch/image.php	(revision 708)
@@ -52,5 +52,5 @@
 
 $httpvars = new HTTPVariables( $HTTP_GET_VARS, $_GET );
-$view = $httpvars->getHttpVar( "view" );
+$view = $httpvars->getHttpVar( "j_view" );
 $clustername = $httpvars->getClusterName();
 
Index: /branches/0.4/web/addons/job_monarch/index.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/index.php	(revision 707)
+++ /branches/0.4/web/addons/job_monarch/index.php	(revision 708)
@@ -47,5 +47,5 @@
 $httpvars = new HTTPVariables( $HTTP_GET_VARS, $_GET );
 $clustername = $httpvars->getClusterName();
-$view = $httpvars->getHttpVar( "view" );
+$view = $httpvars->getHttpVar( "j_view" );
 
 $filter = array();
Index: /branches/0.4/web/addons/job_monarch/overview.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/overview.php	(revision 707)
+++ /branches/0.4/web/addons/job_monarch/overview.php	(revision 708)
@@ -73,5 +73,5 @@
 	$ic->draw();
 
-	$tpl->assign( "clusterimage", "./image.php?". session_name() . "=" . session_id() ."&c=".rawurlencode($clustername)."&view=big-clusterimage".$filter_image_url );
+	$tpl->assign( "clusterimage", "./image.php?". session_name() . "=" . session_id() ."&c=".rawurlencode($clustername)."&j_view=big-clusterimage".$filter_image_url );
 
 	//$tpl->assign( "clusterimage_width", $ic->getWidth() );
Index: /branches/0.4/web/addons/job_monarch/search.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/search.php	(revision 707)
+++ /branches/0.4/web/addons/job_monarch/search.php	(revision 708)
@@ -506,5 +506,5 @@
 					$val = $metrics[$host][$metricname];
 					$class = "metric";
-					$host_link="\"?view=host&c=$cluster_url&h=$host_url&job_start=$job_start&job_stop=$job_stop&period_start=$period_start&period_stop=$period_stop\"";
+					$host_link="\"?j_view=host&c=$cluster_url&h=$host_url&job_start=$job_start&job_stop=$job_stop&period_start=$period_start&period_stop=$period_stop\"";
 
 					if ($val[TYPE]=="timestamp" or $always_timestamp[$metricname]) {
Index: /branches/0.4/web/templates/job_monarch/cluster_extra.tpl
===================================================================
--- /branches/0.4/web/templates/job_monarch/cluster_extra.tpl	(revision 707)
+++ /branches/0.4/web/templates/job_monarch/cluster_extra.tpl	(revision 708)
@@ -1,4 +1,4 @@
 <HR>
 <A HREF="./addons/job_monarch/?c={$cluster}">
-<IMG SRC="./addons/job_monarch/image.php?c={$cluster}&view=small-clusterimage" BORDER=0>
+<IMG SRC="./addons/job_monarch/image.php?c={$cluster}&j_view=small-clusterimage" BORDER=0>
 </A>
Index: /branches/0.4/web/templates/job_monarch/host_extra.tpl
===================================================================
--- /branches/0.4/web/templates/job_monarch/host_extra.tpl	(revision 707)
+++ /branches/0.4/web/templates/job_monarch/host_extra.tpl	(revision 708)
@@ -1,4 +1,4 @@
-<a href="./addons/job_monarch/?c={cluster}&h={host}">
-<IMG SRC="./addons/job_monarch/image.php?c={cluster}&h={host}&view=hostimage" BORDER=0>
+<a href="./addons/job_monarch/?c={$cluster}&h={$host}">
+<IMG SRC="./addons/job_monarch/image.php?c={$cluster}&h={$host}&j_view=hostimage" BORDER=0>
 </a>
 <hr>