Index: /branches/0.4/web/addons/job_monarch/image.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/image.php	(revision 709)
+++ /branches/0.4/web/addons/job_monarch/image.php	(revision 710)
@@ -56,8 +56,8 @@
 
 //printf("clustername = %s\n", $clustername );
-if( isset($f_id) && ($f_id!='')) $filter[f_id]=$id;
-if( isset($f_state) && ($f_state!='')) $filter[f_state]=$state;
-if( isset($f_user) && ($f_user!='')) $filter[f_user]=$user;
-if( isset($f_queue) && ($f_queue!='')) $filter[f_queue]=$queue;
+if( isset($id) && ($id!='')) $filter['id']=$id;
+if( isset($state) && ($state!='')) $filter['state']=$state;
+if( isset($user) && ($user!='')) $filter['user']=$user;
+if( isset($queue) && ($queue!='')) $filter['queue']=$queue;
 
 function drawHostImage() {
@@ -115,14 +115,14 @@
 			switch( $filtername ) {
 
-				case "f_id":
+				case "id":
 					$ic->setFilter( 'jobid', $filtervalue );
 					break;
-				case "f_user":
+				case "user":
 					$ic->setFilter( 'owner', $filtervalue);
 					break;
-				case "f_queue":
+				case "queue":
 					$ic->setFilter( 'queue', $filtervalue);
 					break;
-				case "f_state":
+				case "state":
 					$ic->setFilter( 'status', $filtervalue);
 					break;
Index: /branches/0.4/web/addons/job_monarch/index.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/index.php	(revision 709)
+++ /branches/0.4/web/addons/job_monarch/index.php	(revision 710)
@@ -58,8 +58,8 @@
 	$myfilter_fields = explode( ",", $filterorder );
 } else {
-	if( isset($f_queue) && ($queue!='')) $filter[f_queue]=$queue;
-	if( isset($f_state) && ($state!='')) $filter[f_state]=$state;
-	if( isset($f_user) && ($user!='')) $filter[f_user]=$user;
-	if( isset($f_id) && ($id!='')) $filter[f_id]=$id;
+	if( isset($queue) && ($queue!='')) $filter['queue']=$queue;
+	if( isset($state) && ($state!='')) $filter['state']=$state;
+	if( isset($user) && ($user!='')) $filter['user']=$user;
+	if( isset($id) && ($id!='')) $filter['id']=$id;
 }
 
@@ -71,15 +71,15 @@
 		switch( $myfilter ) {
 
-			case "f_queue":
-				$filter[f_queue]=$queue;
+			case "queue":
+				$filter[queue]=$queue;
 				break;
 			case "state":
-				$filter[f_state]=$state;
+				$filter[state]=$state;
 				break;
 			case "user":
-				$filter[f_user]=$user;
+				$filter[user]=$user;
 				break;
 			case "id":
-				$filter[f_id]=$id;
+				$filter[id]=$id;
 				break;
 		}
Index: /branches/0.4/web/addons/job_monarch/overview.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/overview.php	(revision 709)
+++ /branches/0.4/web/addons/job_monarch/overview.php	(revision 710)
@@ -57,5 +57,5 @@
 	foreach( $filter as $filtername => $filtervalue ) 
 	{
-		$tpl->assign( "f_".$filtername, $filtervalue );
+		$tpl->assign( $filtername, $filtervalue );
 
 		$filter_image_url	.= "&$filtername=$filtervalue";
@@ -82,5 +82,5 @@
 	$tpl->gotoBlock( "_ROOT" );
 
-	$tpl->assign( "f_order", $filterorder );
+	$tpl->assign( "order", $filterorder );
 
 	if( array_key_exists( "id", $filter ) ) 
Index: /branches/0.4/web/addons/job_monarch/templates/overview.tpl
===================================================================
--- /branches/0.4/web/addons/job_monarch/templates/overview.tpl	(revision 709)
+++ /branches/0.4/web/addons/job_monarch/templates/overview.tpl	(revision 710)
@@ -162,9 +162,9 @@
 <INPUT TYPE="HIDDEN" NAME="sortorder" VALUE="{sortorder}">
 <INPUT TYPE="HIDDEN" NAME="c" VALUE="{clustername}">
-<INPUT TYPE="HIDDEN" NAME="queue" VALUE="{f_queue}">
-<INPUT TYPE="HIDDEN" NAME="state" VALUE="{f_state}">
-<INPUT TYPE="HIDDEN" NAME="user" VALUE="{f_user}">
-<INPUT TYPE="HIDDEN" NAME="id" VALUE="{f_id}">
-<INPUT TYPE="HIDDEN" NAME="filterorder" VALUE="{f_order}">
+<INPUT TYPE="HIDDEN" NAME="queue" VALUE="{queue}">
+<INPUT TYPE="HIDDEN" NAME="state" VALUE="{state}">
+<INPUT TYPE="HIDDEN" NAME="user" VALUE="{user}">
+<INPUT TYPE="HIDDEN" NAME="id" VALUE="{id}">
+<INPUT TYPE="HIDDEN" NAME="filterorder" VALUE="{order}">
 
 <TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="2" BORDER=0>
Index: /branches/0.4/web/addons/job_monarch/templates/search.tpl
===================================================================
--- /branches/0.4/web/addons/job_monarch/templates/search.tpl	(revision 709)
+++ /branches/0.4/web/addons/job_monarch/templates/search.tpl	(revision 710)
@@ -200,5 +200,5 @@
 <INPUT TYPE="HIDDEN" NAME="sortby" VALUE="{sortby}">
 <INPUT TYPE="HIDDEN" NAME="sortorder" VALUE="{sortorder}">
-<INPUT TYPE="HIDDEN" NAME="filterorder" VALUE="{f_order}">
+<INPUT TYPE="HIDDEN" NAME="filterorder" VALUE="{order}">
 
 <TABLE WIDTH="100%" CELLPADDING="2" CELLSPACING="2" BORDER=0>