Index: /branches/0.4/web/addons/job_monarch/image.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/image.php	(revision 710)
+++ /branches/0.4/web/addons/job_monarch/image.php	(revision 711)
@@ -58,5 +58,5 @@
 if( isset($id) && ($id!='')) $filter['id']=$id;
 if( isset($state) && ($state!='')) $filter['state']=$state;
-if( isset($user) && ($user!='')) $filter['user']=$user;
+if( isset($owner) && ($owner!='')) $filter['owner']=$owner;
 if( isset($queue) && ($queue!='')) $filter['queue']=$queue;
 
@@ -118,5 +118,5 @@
 					$ic->setFilter( 'jobid', $filtervalue );
 					break;
-				case "user":
+				case "owner":
 					$ic->setFilter( 'owner', $filtervalue);
 					break;
Index: /branches/0.4/web/addons/job_monarch/index.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/index.php	(revision 710)
+++ /branches/0.4/web/addons/job_monarch/index.php	(revision 711)
@@ -60,5 +60,5 @@
 	if( isset($queue) && ($queue!='')) $filter['queue']=$queue;
 	if( isset($state) && ($state!='')) $filter['state']=$state;
-	if( isset($user) && ($user!='')) $filter['user']=$user;
+	if( isset($owner) && ($owner!='')) $filter['owner']=$owner;
 	if( isset($id) && ($id!='')) $filter['id']=$id;
 }
@@ -72,14 +72,14 @@
 
 			case "queue":
-				$filter[queue]=$queue;
+				$filter['queue']=$queue;
 				break;
 			case "state":
-				$filter[state]=$state;
+				$filter['state']=$state;
 				break;
-			case "user":
-				$filter[user]=$user;
+			case "owner":
+				$filter['owner']=$owner;
 				break;
 			case "id":
-				$filter[id]=$id;
+				$filter['id']=$id;
 				break;
 		}
Index: /branches/0.4/web/addons/job_monarch/libtoga.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/libtoga.php	(revision 710)
+++ /branches/0.4/web/addons/job_monarch/libtoga.php	(revision 711)
@@ -176,5 +176,5 @@
 	}
 
-	function searchDbase( $id = null, $queue = null, $user = null, $name = null, $start_from_time = null, $start_to_time = null, $end_from_time = null, $end_to_time = null )
+	function searchDbase( $id = null, $queue = null, $owner = null, $name = null, $start_from_time = null, $start_to_time = null, $end_from_time = null, $end_to_time = null )
 	{
 		global $SEARCH_RESULT_LIMIT;
@@ -193,7 +193,7 @@
 				$query_args[] = "job_queue ='$queue'";
 			}
-			if( $user )
-			{
-				$query_args[] = "job_owner ='$user'";
+			if( $owner )
+			{
+				$query_args[] = "job_owner ='$owner'";
 			}
 			if( $name )
Index: /branches/0.4/web/addons/job_monarch/overview.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/overview.php	(revision 710)
+++ /branches/0.4/web/addons/job_monarch/overview.php	(revision 711)
@@ -88,7 +88,7 @@
 		$piefilter = 'id';
 	} 
-	else if( array_key_exists( "user", $filter ) ) 
-	{
-		$piefilter = 'user';
+	else if( array_key_exists( "owner", $filter ) ) 
+	{
+		$piefilter = 'owner';
 	} 
 	else if( array_key_exists( "queue", $filter ) ) 
@@ -312,5 +312,5 @@
 					}
 				}
-				else if( $piefilter == 'user' )
+				else if( $piefilter == 'owner' )
 				{
 					if( $jobs[$myjob]['owner'] != $filter[$piefilter] )
@@ -427,5 +427,5 @@
 		{
 				$state		= $jobattrs['status'];
-				$user 		= $jobattrs['owner'];
+				$owner      = $jobattrs['owner'];
 				$queue 		= $jobattrs['queue'];
 				$name 		= $jobattrs['name'];
@@ -458,6 +458,6 @@
 						break;
 
-					case "user":
-						$sorted[$jobid] = $user;
+					case "owner":
+						$sorted[$jobid] = $owner;
 						break;
 
@@ -727,5 +727,5 @@
 					$display_job = 0;
 				}
-				else if( $filtername == 'user' && $jobs[$jobid]['owner'] != $filtervalue )
+				else if( $filtername == 'owner' && $jobs[$jobid]['owner'] != $filtervalue )
 				{
 					$display_job = 0;
@@ -756,5 +756,5 @@
 				$tpl->assign( "fullstate", $fullstate );
 				
-				$tpl->assign( "user", $jobs[$jobid]['owner'] );
+				$tpl->assign( "owner", $jobs[$jobid]['owner'] );
 				$tpl->assign( "queue", $jobs[$jobid]['queue'] );
 
Index: /branches/0.4/web/addons/job_monarch/search.php
===================================================================
--- /branches/0.4/web/addons/job_monarch/search.php	(revision 710)
+++ /branches/0.4/web/addons/job_monarch/search.php	(revision 711)
@@ -26,5 +26,5 @@
 
 function validateFormInput() {
-	global $clustername, $tpl, $id, $user, $name, $start_from_time, $start_to_time, $queue;
+	global $clustername, $tpl, $id, $owner, $name, $start_from_time, $start_to_time, $queue;
 	global $end_from_time, $end_to_time, $period_start, $period_stop;
 
@@ -35,5 +35,5 @@
 	$none_set = 0;
 
-	if( $id == '' and $user == '' and $name == '' and $start_from_time == '' and $start_to_time == '' and $queue == '' and $end_from_time == '' and $end_to_time == '') {
+	if( $id == '' and $owner== '' and $name == '' and $start_from_time == '' and $start_to_time == '' and $queue == '' and $end_from_time == '' and $end_to_time == '') {
 		$error = 1;
 		$show_msg = 1;
@@ -168,5 +168,5 @@
 
                         $state = $jobattrs[status];
-                        $user = $jobattrs[owner];
+                        $owner = $jobattrs[owner];
                         $queue = $jobattrs[queue];
                         $name = $jobattrs[name];
@@ -194,6 +194,6 @@
                                         break;
 
-                                case "user":
-                                        $sorted[$jobid] = $user;
+                                case "owner":
+                                        $sorted[$jobid] = $owner;
                                         break;
 
@@ -252,5 +252,5 @@
 
 function makeSearchPage() {
-	global $clustername, $tpl, $id, $user, $name, $start_from_time, $start_to_time, $queue;
+	global $clustername, $tpl, $id, $owner, $name, $start_from_time, $start_to_time, $queue;
 	global $end_from_time, $end_to_time, $filter, $default_showhosts, $m, $hosts_up, $hc;
 	global $period_start, $period_stop, $sortby, $sortorder, $COLUMN_REQUESTED_MEMORY;
@@ -269,5 +269,5 @@
 	$tpl->assign( "cluster", $clustername );
 	$tpl->assign( "id_value", $id );
-	$tpl->assign( "user_value", $user );
+	$tpl->assign( "owner_value", $owner);
 	$tpl->assign( "queue_value", $queue );
 	$tpl->assign( "name_value", $name );
@@ -287,5 +287,5 @@
 		if( $end_from_time ) $end_from_time = datetimeToEpoch( $end_from_time );
 		if( $end_to_time ) $end_to_time = datetimeToEpoch( $end_to_time );
-		$search_ids = $tdb->searchDbase( $id, $queue, $user, $name, $start_from_time, $start_to_time, $end_from_time, $end_to_time );
+		$search_ids = $tdb->searchDbase( $id, $queue, $owner, $name, $start_from_time, $start_to_time, $end_from_time, $end_to_time );
 
 		if( ($tdb->resultcount) > (int) $SEARCH_RESULT_LIMIT ) {
@@ -334,5 +334,5 @@
 			$tpl->assign( "id", $job[id] );
 			$tpl->assign( "state", $job[status] );
-			$tpl->assign( "user", $job[owner] );
+			$tpl->assign( "owner", $job[owner] );
 			$tpl->assign( "queue", $job[queue] );
 			$tpl->assign( "name", $job[name] );
Index: /branches/0.4/web/addons/job_monarch/templates/overview.tpl
===================================================================
--- /branches/0.4/web/addons/job_monarch/templates/overview.tpl	(revision 710)
+++ /branches/0.4/web/addons/job_monarch/templates/overview.tpl	(revision 711)
@@ -164,5 +164,5 @@
 <INPUT TYPE="HIDDEN" NAME="queue" VALUE="{queue}">
 <INPUT TYPE="HIDDEN" NAME="state" VALUE="{state}">
-<INPUT TYPE="HIDDEN" NAME="user" VALUE="{user}">
+<INPUT TYPE="HIDDEN" NAME="owner" VALUE="{owner}">
 <INPUT TYPE="HIDDEN" NAME="id" VALUE="{id}">
 <INPUT TYPE="HIDDEN" NAME="filterorder" VALUE="{order}">
@@ -172,5 +172,5 @@
 <TH><B><A HREF="#" onClick="setSort( 'id' )" ALT="Jobid" TITLE="Jobid">Id</A></B></TH>
 <TH><B><A HREF="#" onClick="setSort( 'state' )" ALT="State" TITLE="State">S</A></B></TH>
-<TH><B><A HREF="#" onClick="setSort( 'user' )">User</A></B></TH>
+<TH><B><A HREF="#" onClick="setSort( 'owner' )">Owner</A></B></TH>
 <TH><B><A HREF="#" onClick="setSort( 'queue' )">Queue</A></B></TH>
 <TH><B><A HREF="#" onClick="setSort( 'name' )" ALT="Jobname" TITLE="Jobname">Name</A></B></TH>
@@ -194,5 +194,5 @@
     <TD><A HREF="#" onClick="setFilter( 'id', '{id}' )">{id}</A></TD>
     <TD><A HREF="#" onClick="setFilter( 'state', '{state}' )" ALT="{fullstate}" TITLE="{fullstate}">{state}</A></TD>
-    <TD><A HREF="#" onClick="setFilter( 'user', '{user}' )">{user}</A></TD>
+    <TD><A HREF="#" onClick="setFilter( 'owner', '{owner}' )">{owner}</A></TD>
     <TD><A HREF="#" onClick="setFilter( 'queue', '{queue}' )">{queue}</A></TD>
     <TD ALT="{fulljobname}" TITLE="{fulljobname}">
Index: /branches/0.4/web/addons/job_monarch/templates/search.tpl
===================================================================
--- /branches/0.4/web/addons/job_monarch/templates/search.tpl	(revision 710)
+++ /branches/0.4/web/addons/job_monarch/templates/search.tpl	(revision 711)
@@ -97,5 +97,5 @@
   </TD>
   <TD>
-  <INPUT TYPE="TEXT" NAME="user" VALUE="{user_value}">
+  <INPUT TYPE="TEXT" NAME="owner" VALUE="{owner_value}">
   </TD>
 
@@ -206,5 +206,5 @@
 <TH><B><A HREF="#" onClick="setSort( 'id' )" ALT="Jobid" TITLE="Jobid">Id</A></B></TH>
 <TH><B><A HREF="#" onClick="setSort( 'state' )" ALT="State" TITLE="State">S</A></B></TH>
-<TH><B><A HREF="#" onClick="setSort( 'user' )">User</A></B></TH>
+<TH><B><A HREF="#" onClick="setSort( 'owner' )">Owner</A></B></TH>
 <TH><B><A HREF="#" onClick="setSort( 'queue' )">Queue</A></B></TH>
 <TH><B><A HREF="#" onClick="setSort( 'name' )" ALT="Jobname" TITLE="Jobname">Name</A></B></TH>
@@ -226,5 +226,5 @@
     <TD><A HREF="#" onClick="setFilter( 'id', '{id}' )">{id}</A></TD>
     <TD><A HREF="#" onClick="setFilter( 'state', '{state}' )">{state}</A></TD>
-    <TD><A HREF="#" onClick="setFilter( 'user', '{user}' )">{user}</A></TD>
+    <TD><A HREF="#" onClick="setFilter( 'owner', '{owner}' )">{owner}</A></TD>
     <TD><A HREF="#" onClick="setFilter( 'queue', '{queue}' )">{queue}</A></TD>
     <TD ALT="{fulljobname}" TITLE="{fulljobname}">